glibmm: Gio::Resource Class Reference

glibmm 2.84.0

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Symbols | List of all members
Gio::Resource Class Referencefinal

Resource framework. More...

`#include <giomm/resource.h>`

## Public Types
enum class | Flags { Flags::NONE = 0x0 , Flags::COMPRESSED = (1<<0) }
| GResourceFlags give information about a particular file inside a resource bundle. More...
enum class | LookupFlags { LookupFlags::NONE = 0x0 }
| GResourceLookupFlags determine how resource path lookups are handled. More...

## Public Member Functions
void | reference () const
| Increment the reference count for this object.
void | unreference () const
| Decrement the reference count for this object.
GResource * | gobj ()
| Provides access to the underlying C instance.
const GResource * | gobj () const
| Provides access to the underlying C instance.
GResource * | gobj_copy () const
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
| Resource ()=delete
| Resource (const Resource &)=delete
Resource & | operator= (const Resource &)=delete
Glib::RefPtr< InputStream > | open_stream (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE) const
| Looks for a file at the specified path in the resource and returns a Gio::InputStream that lets you read the data.
Glib::RefPtr< const Glib::Bytes > | lookup_data (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE) const
| Looks for a file at the specified path in the resource and returns a Glib::Bytes that lets you directly access the data in memory.
std::vector< std::string > | enumerate_children (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE) const
| Returns all the names of children at the specified path in the resource.
void | get_info (const std::string & path, gsize &size, Flags & flags, LookupFlags lookup_flags=LookupFlags::NONE) const
| Looks for a file at the specified path in the resource and if found returns information about it.
void | get_file_exists (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE) const
| Looks for a file at the specified path in the resource.
bool | get_file_exists_nothrow (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE) const
| Looks for a file at the specified path in the resource.
bool | has_children (const std::string & path) const
| Returns whether the specified path in the resource has children.
void | register_global ()
| Registers the resource with the process-global set of resources.
void | unregister_global ()
| Unregisters the resource from the process-global set of resources.

## Static Public Member Functions
static Glib::RefPtr< Resource > | create_from_data (const Glib::RefPtr< const Glib::Bytes > &data)
| Creates a Gio::Resource from a reference to the binary resource bundle.
static Glib::RefPtr< Resource > | create_from_file (const std::string & filename)
| Loads a binary resource bundle and creates a Gio::Resource representation of it, allowing you to query it for data.
static Glib::RefPtr< InputStream > | open_stream_global (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE)
| Looks for a file at the specified path in the set of globally registered resources and returns a Gio::InputStream that lets you read the data.
static Glib::RefPtr< const Glib::Bytes > | lookup_data_global (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE)
| Looks for a file at the specified path in the set of globally registered resources and returns a Glib::Bytes that lets you directly access the data in memory.
static std::vector< std::string > | enumerate_children_global (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE)
| Returns all the names of children at the specified path in the set of globally registered resources.
static void | get_info_global (const std::string & path, gsize &size, Flags & flags, LookupFlags lookup_flags=LookupFlags::NONE)
| Looks for a file at the specified path in the set of globally registered resources and if found returns information about it.
static void | get_file_exists_global (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE)
| Looks for a file at the specified path in the set of globally registered resources.
static bool | get_file_exists_global_nothrow (const std::string & path, LookupFlags lookup_flags=LookupFlags::NONE)
| Looks for a file at the specified path in the set of globally registered resources.
static bool | has_children_global (const std::string & path)
| Returns whether the specified path in the set of globally registered resources has children.

## Protected Member Functions
void | operator delete (void *, std::size_t)

## Related Symbols
(Note that these are not member symbols.)
Glib::RefPtr< Gio::Resource > | wrap (GResource * object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

Resource framework.

Applications and libraries often contain binary or textual data that is really part of the application, rather than user data. For instance Gtk::Builder .ui files, splashscreen images, Gio::Menu markup xml, CSS files, icons, etc. These are often shipped as files in `$datadir/appname`, or manually included as literal strings in the code.

The Gio::Resource API and the `glib-compile-resources` program provide a convenient and efficient alternative to this which has some nice properties. You maintain the files as normal files, so it's easy to edit them, but during the build the files are combined into a binary bundle that is linked into the executable. This means that loading the resource files is efficient (as they are already in memory, shared with other instances) and simple (no need to check for things like I/O errors or locate the files in the filesystem). It also makes it easier to create relocatable applications.

Resource files can also be marked as compressed. Such files will be included in the resource bundle in a compressed form, but will be automatically uncompressed when the resource is used. This is very useful e.g. for larger text files that are parsed once (or rarely) and then thrown away.

Resource files can also be marked to be preprocessed, by setting the value of the `preprocess` attribute to a comma-separated list of preprocessing options. The only options currently supported are:

xml-stripblanks

  which will use the `xmllint` command to strip ignorable whitespace from the xml file. For this to work, the `XMLLINT` environment variable must be set to the full path to the `xmllint` executable, or `xmllint` must be in the `PATH`; otherwise the preprocessing step is skipped.

to-pixdata
  which will use the `gdk-pixbuf-pixdata` command to convert images to the GdkPixdata format, which allows you to create pixbufs directly using the data inside the resource file, rather than an (uncompressed) copy of it. For this, the `gdk-pixbuf-pixdata` program must be in the PATH, or the `GDK_PIXBUF_PIXDATA` environment variable must be set to the full path to the `gdk-pixbuf-pixdata` executable; otherwise the resource compiler will abort.

Resource bundles are created by the `glib-compile-resources` program which takes an xml file that describes the bundle, and a set of files that the xml references. These are combined into a binary resource bundle.

An example resource description:

<?xml version="1.0" encoding="UTF-8"?>
<gresources>
<gresource prefix="/org/gtk/Example">
<file>data/splashscreen.png</file>
<file compressed="true">dialog.ui</file>
<file preprocess="xml-stripblanks">menumarkup.xml</file>
</gresource>
</gresources>
data
constexpr auto data(_Container &__cont) noexcept(noexcept(__cont.data())) -> decltype(__cont.data())

This will create a resource bundle with the following files:

/org/gtk/Example/data/splashscreen.png
/org/gtk/Example/dialog.ui
/org/gtk/Example/menumarkup.xml

Note that all resources in the process share the same namespace, so use java-style path prefixes (like in the above example) to avoid conflicts.

You can then use `glib-compile-resources` to compile the xml to a binary bundle that you can load with Gio::Resource::create_from_file(). However, it's more common to use the –generate-source and –generate-header arguments to create a source file and header to link directly into your application.

Once a Gio::Resource has been created and registered all the data in it can be accessed globally in the process by using API calls like Gio::Resource::open_stream_from_global_resources() to stream the data or Gio::Resource::lookup_data_in_global_resources() to get a direct pointer to the data. You can also use uris like "resource:///org/gtk/Example/data/splashscreen.png" with Gio::File to access the resource data.

There are two forms of the generated source, the default version uses the compiler support for constructor and destructor functions (where available) to automatically create and register the Gio::Resource on startup or library load time. If you pass –manual-register, two functions to register/unregister the resource is instead created. This requires an explicit initialization call in your application/library, but it works on all platforms, even on the minor ones where this is not available. (Constructor support is available for at least Win32, MacOS and Linux.)

Note that resource data can point directly into the data segment of e.g. a library, so if you are unloading libraries during runtime you need to be very careful with keeping around pointers to data from a resource, as this goes away when the library is unloaded. However, in practice this is not generally a problem, since most resource accesses is for your own resources, and resource data is often used once, during parsing, and then released.

Since glibmm 2.44

## Constructor & Destructor Documentation

## ◆ Resource() [1/2]

Gio::Resource::Resource | ( |  | ) |
| delete

## ◆ Resource() [2/2]

Gio::Resource::Resource | ( | const Resource & |  | ) |
| delete

## Member Function Documentation

## ◆ create_from_data()

static Glib::RefPtr< Resource > Gio::Resource::create_from_data | ( | const Glib::RefPtr< const Glib::Bytes > & | data | ) |
| static

Creates a Gio::Resource from a reference to the binary resource bundle.

This will keep a reference to data while the resource lives, so the data should not be modified or freed.

If you want to use this resource in the global resource namespace you need to register it with gio_resources_register().

Note
  data must be backed by memory that is at least pointer aligned. Otherwise this function will internally create a copy of the memory since GLib 2.56, or in older versions fail and exit the process.

If data is empty or corrupt, Gio::ResourceError::INTERNAL will be returned.

Since glibmm 2.44

Parameters

  data | A Glib::Bytes.

Returns
  A new Gio::Resource, or `nullptr` on error.

Exceptions

  Glib::FileError |

## ◆ create_from_file()

static Glib::RefPtr< Resource > Gio::Resource::create_from_file | ( | const std::string & | filename | ) |
| static

Loads a binary resource bundle and creates a Gio::Resource representation of it, allowing you to query it for data.

If you want to use this resource in the global resource namespace you need to register it with gio_resources_register().

If filename is empty or the data in it is corrupt, Gio::ResourceError::INTERNAL will be returned. If filename doesn’t exist, or there is an error in reading it, an error from Glib::MappedFile::new() will be returned.

Since glibmm 2.44

Parameters

  filename | The path of a filename to load, in the GLib filename encoding.

Returns
  A new Gio::Resource, or `nullptr` on error.

Exceptions

  Glib::FileError |

## ◆ enumerate_children()

std::vector< std::string > Gio::Resource::enumerate_children | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE ) const

Returns all the names of children at the specified path in the resource.

The return result is a `nullptr` terminated list of strings which should be released with glib_strfreev().

If path is invalid or does not exist in the Gio::Resource, Gio::ResourceError::NOT_FOUND will be returned.

lookup_flags controls the behaviour of the lookup.

Since glibmm 2.44

Parameters

  path | A path name inside the resource.
  lookup_flags | A Gio::ResourceLookupFlags.

Returns
  An array of constant strings.

Exceptions

  Gio::ResourceError |

## ◆ enumerate_children_global()

static std::vector< std::string > Gio::Resource::enumerate_children_global | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE )
| static

Returns all the names of children at the specified path in the set of globally registered resources.

The return result is a `nullptr` terminated list of strings which should be released with glib_strfreev().

lookup_flags controls the behaviour of the lookup.

Since glibmm 2.44

Parameters

  path | A path name inside the resource.
  lookup_flags | A Gio::ResourceLookupFlags.

Returns
  An array of constant strings.

Exceptions

  Gio::ResourceError |

## ◆ get_file_exists()

void Gio::Resource::get_file_exists | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE ) const

Looks for a file at the specified path in the resource.

lookup_flags controls the behaviour of the lookup.

Since glibmm 2.44

Parameters

  path | A pathname inside the resource.
  lookup_flags | A LookupFlags.

Exceptions

  Gio::ResourceError | if the file was not found.

## ◆ get_file_exists_global()

static void Gio::Resource::get_file_exists_global | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE )
| static

Looks for a file at the specified path in the set of globally registered resources.

lookup_flags controls the behaviour of the lookup.

Since glibmm 2.44

Parameters

  path | A pathname inside the resource.
  lookup_flags | A LookupFlags.

Exceptions

  Gio::ResourceError | if the file was not found.

## ◆ get_file_exists_global_nothrow()

static bool Gio::Resource::get_file_exists_global_nothrow | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE )
| static

Looks for a file at the specified path in the set of globally registered resources.

lookup_flags controls the behaviour of the lookup. This method returns a `bool` instead of throwing in exception in case of errors.

Since glibmm 2.44

Parameters

  path | A pathname inside the resource.
  lookup_flags | A LookupFlags.

Returns
  `true` if the file was found, `false` if there were errors.

## ◆ get_file_exists_nothrow()

bool Gio::Resource::get_file_exists_nothrow | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE ) const

Looks for a file at the specified path in the resource.

lookup_flags controls the behaviour of the lookup. This method returns a `bool` instead of throwing in exception in case of errors.

Since glibmm 2.44

Parameters

  path | A pathname inside the resource.
  lookup_flags | A LookupFlags.

Returns
  `true` if the file was found, `false` if there were errors.

## ◆ get_info()

void Gio::Resource::get_info | ( | const std::string & | path,
|  | gsize & | size,
|  | Flags & | flags,
|  | LookupFlags | lookup_flags = LookupFlags::NONE ) const

Looks for a file at the specified path in the resource and if found returns information about it.

lookup_flags controls the behaviour of the lookup.

Since glibmm 2.44

Parameters

  | path | A pathname inside the resource.
  [out] | size | A location to place the length of the contents of the file.
  [out] | flags | A location to place the flags about the file.
  | lookup_flags | A LookupFlags.

Exceptions

  Gio::ResourceError | if the file was not found.

## ◆ get_info_global()

static void Gio::Resource::get_info_global | ( | const std::string & | path,
|  | gsize & | size,
|  | Flags & | flags,
|  | LookupFlags | lookup_flags = LookupFlags::NONE )
| static

Looks for a file at the specified path in the set of globally registered resources and if found returns information about it.

lookup_flags controls the behaviour of the lookup.

Since glibmm 2.44

Parameters

  | path | A pathname inside the resource.
  [out] | size | A location to place the length of the contents of the file.
  [out] | flags | A location to place the flags about the file.
  | lookup_flags | A LookupFlags.

Exceptions

  Gio::ResourceError | if the file was not found.

## ◆ gobj() [1/2]

GResource * Gio::Resource::gobj | ( |  | ) |

Provides access to the underlying C instance.

## ◆ gobj() [2/2]

const GResource * Gio::Resource::gobj | ( |  | ) | const

Provides access to the underlying C instance.

## ◆ gobj_copy()

GResource * Gio::Resource::gobj_copy | ( |  | ) | const

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ has_children()

bool Gio::Resource::has_children | ( | const std::string & | path | ) | const

Returns whether the specified path in the resource has children.

Since glibmm 2.84

Parameters

  path | A pathname inside the resource.

Returns
  `true` if path has children.

## ◆ has_children_global()

static bool Gio::Resource::has_children_global | ( | const std::string & | path | ) |
| static

Returns whether the specified path in the set of globally registered resources has children.

Since glibmm 2.84

Parameters

  path | A pathname.

Returns
  `true` if patch has children.

## ◆ lookup_data()

Glib::RefPtr< const Glib::Bytes > Gio::Resource::lookup_data | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE ) const

Looks for a file at the specified path in the resource and returns a Glib::Bytes that lets you directly access the data in memory.

The data is always followed by a zero byte, so you can safely use the data as a C string. However, that byte is not included in the size of the Glib::Bytes.

For uncompressed resource files this is a pointer directly into the resource bundle, which is typically in some read-only data section in the program binary. For compressed files, memory is allocated on the heap and the data is automatically uncompressed.

lookup_flags controls the behaviour of the lookup.

This can return error Gio::ResourceError::NOT_FOUND if path was not found in resource, or Gio::ResourceError::INTERNAL if decompression of a compressed resource failed.

Since glibmm 2.44

Parameters

  path | A path name inside the resource.
  lookup_flags | A Gio::ResourceLookupFlags.

Returns
  Glib::Bytes or `nullptr` on error.

Exceptions

  Gio::ResourceError |

## ◆ lookup_data_global()

static Glib::RefPtr< const Glib::Bytes > Gio::Resource::lookup_data_global | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE )
| static

Looks for a file at the specified path in the set of globally registered resources and returns a Glib::Bytes that lets you directly access the data in memory.

The data is always followed by a zero byte, so you can safely use the data as a C string. However, that byte is not included in the size of the Glib::Bytes.

For uncompressed resource files this is a pointer directly into the resource bundle, which is typically in some read-only data section in the program binary. For compressed files we allocate memory on the heap and automatically uncompress the data.

lookup_flags controls the behaviour of the lookup.

Since glibmm 2.44

Parameters

  path | A path name inside the resource.
  lookup_flags | A Gio::ResourceLookupFlags.

Returns
  Glib::Bytes or `nullptr` on error.

Exceptions

  Gio::ResourceError |

## ◆ open_stream()

Glib::RefPtr< InputStream > Gio::Resource::open_stream | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE ) const

Looks for a file at the specified path in the resource and returns a Gio::InputStream that lets you read the data.

lookup_flags controls the behaviour of the lookup.

The only error this can return is Gio::ResourceError::NOT_FOUND, if path was not found in resource.

Since glibmm 2.44

Parameters

  path | A path name inside the resource.
  lookup_flags | A Gio::ResourceLookupFlags.

Returns
  Gio::InputStream or `nullptr` on error.

Exceptions

  Gio::ResourceError |

## ◆ open_stream_global()

static Glib::RefPtr< InputStream > Gio::Resource::open_stream_global | ( | const std::string & | path,
|  | LookupFlags | lookup_flags = LookupFlags::NONE )
| static

Looks for a file at the specified path in the set of globally registered resources and returns a Gio::InputStream that lets you read the data.

lookup_flags controls the behaviour of the lookup.

Since glibmm 2.44

Parameters

  path | A path name inside the resource.
  lookup_flags | A Gio::ResourceLookupFlags.

Returns
  Gio::InputStream or `nullptr` on error.

Exceptions

  Gio::ResourceError |

## ◆ operator delete()

void Gio::Resource::operator delete | ( | void * | ,
|  | std::size_t | )
| protected

## ◆ operator=()

Resource & Gio::Resource::operator= | ( | const Resource & |  | ) |
| delete

## ◆ reference()

void Gio::Resource::reference | ( |  | ) | const

Increment the reference count for this object.

You should never need to do this manually - use the object via a RefPtr instead.

## ◆ register_global()

void Gio::Resource::register_global | ( |  | ) |

Registers the resource with the process-global set of resources.

Once a resource is registered the files in it can be accessed with the global resource lookup functions like gio_resources_lookup_data().

Since glibmm 2.44

## ◆ unreference()

void Gio::Resource::unreference | ( |  | ) | const

Decrement the reference count for this object.

You should never need to do this manually - use the object via a RefPtr instead.

## ◆ unregister_global()

void Gio::Resource::unregister_global | ( |  | ) |

Unregisters the resource from the process-global set of resources.

Since glibmm 2.44

## Friends And Related Symbol Documentation

## ◆ wrap()

Glib::RefPtr< Gio::Resource > wrap | ( | GResource * | object,
|  | bool | take_copy = false )
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.